﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace AjaxQ3Webinar
{
  public partial class _4_GridVirtualization : System.Web.UI.Page
  {

    private static readonly Random random = new Random();

    static string[] contactNames = new string[] { "Antonio Moreno", "Elizabeth Lincoln", "Hanna Moos", "Jaime Yorres", "Georg Pipps", 
        "Pascale Cartrain", "Paul Henriot", "Matti Karttunen", "Patricio Simpson","Howard Snyder"};
    static string[] companyNames = new string[] { "Blauer See Delikatessen", "Folies gourmandes", "Hungry Coyote Import Store", "Let's Stop N Shop", 
            "B's Beverages", "QUICK-Stop", "Split Rail Beer & Ale", "Wartian Herkku","Santé Gourmet","Romero y tomillo" };
    static string[] contactTitles = new string[] { "Marketing Assistant", "Sales Associate", "Sales Agent", "Sales Representative", 
            "Owner", "Sales Manager", "Accounting Manager","Marketing Manager","Sales Consultant","Accountant"};
    static string[] countries = new string[] { "Bulgaria", "USA", "Austria", "Germany", "Italy", "England", "Argentina", "Brazil", "France", "Spain" };
    static double[] ratings = { 2.5, 3.4, 1.5, 5.9, 7, 1.1, 5.5, 6.1, 3, 6.7 };



    protected void Page_Load(object sender, EventArgs e)
    {
      theGrid.MasterTableView.PagerStyle.PageSizes = new int[] {50, 100, 200, 1000};
    }

    protected void theGrid_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
      theGrid.DataSource = dataSource;
    }

    public List<Customer> dataSource
    {
      get
      {
        object obj = Application["VirtualizationDataSource"];
        if (obj == null)
        {
          List<Customer> customers = new List<Customer>();
          for (int i = 0; i < 100000; i++)
          {
            int titlesIndex = random.Next() % 10;
            int companyIndex = random.Next() % 10;
            int contactIndex = random.Next() % 10;
            int ratingIndex = random.Next() % 10;
            int countryIndex = random.Next() % 10;
            customers.Add(new Customer()
            {
              ID = i + 1,
              ContactTitle = contactTitles[titlesIndex],
              CompanyName = companyNames[companyIndex],
              ContactName = contactNames[contactIndex],
              Rating = ratings[ratingIndex],
              Country = countries[countryIndex]
            });
          }
          Application["VirtualizationDataSource"] = customers;
        }
        return (List<Customer>)Application["VirtualizationDataSource"];
      }
      set
      {
        Application["VirtualizationDataSource"] = value;
      }
    }


    [Serializable]
    public class Customer
    {
      public int ID { get; set; }
      public string CompanyName { get; set; }
      public string ContactName { get; set; }
      public string ContactTitle { get; set; }
      public string Country { get; set; }
      public double Rating { get; set; }
    }

  
  }
}